#!/bin/sh

# replace Bearer abcd by your private token on instances.social api

# warning, this script list down instance or who have a problem, so don't delete these on your instance directly

psql -d mastodon -c "SELECT DISTINCT domain FROM accounts;" > domains.list

echo "$(tail -n +4 domains.list)" > domains.list

for domain in `cat domains.list`; do
	echo $domain
	if ping -c 4 $domain 
	then
	   if [ `curl -H "Authorization: Bearer abcd" https://instances.social/api/1.0/instances/show?name=$domain 2>&1  | grep \"up\":false |wc -l` -eq 1 ]; then 
			echo $domain >> no_response.list
		else
			echo $domain is up
		fi;
	else
	   echo $domain >> no_response.list
	fi
done

for domain in `cat no_response.list`; do
        echo https://$domain/about
        if [ `curl --connect-timeout 10 -I http://$domain/about  2>&1 | grep 301 |wc -l` -eq 1 ]; then
                if [ `curl --connect-timeout 10 -I https://$domain/about  2>&1 | grep 200 |wc -l` -eq 1 ]; then
                        sed -i "/$domain/d" no_response.list
                fi;
        elif [ `curl --connect-timeout 10 -I http://$domain/about  2>&1 | grep 200 |wc -l` -eq 1 ]; then
                sed -i "/$domain/d" no_response.list
        fi;
        elif [ `curl --connect-timeout 10 -I https://$domain/about  2>&1 | grep 200 |wc -l` -eq 1 ]; then
                sed -i "/$domain/d" no_response.list
        fi;
done


for domain in `cat no_response.list`; do
        echo https://$domain
        if [ `curl --connect-timeout 10 -I https://$domain/about  2>&1 | grep 200 |wc -l` -eq 1 ]; then
                sed -i "/$domain/d" no_response.list
        fi;
done